package ch.std.jumpstart;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.boot.test.context.SpringBootTest.WebEnvironment;
import org.springframework.boot.test.web.client.TestRestTemplate;
import org.springframework.boot.web.server.LocalServerPort;
import org.springframework.test.context.junit4.SpringRunner;

import ch.std.jumpstart.dto.CityDTO;

@RunWith(SpringRunner.class)
@SpringBootTest(webEnvironment = WebEnvironment.RANDOM_PORT)
public class JumpstartApplicationJpaTests {

	@LocalServerPort
    private int port;

    @Autowired
	private TestRestTemplate restTemplate;

    @Test
	public void contextLoads() {
	}
    
	@Test
	public void testCityAutoCompleteController() throws Exception {
		String url = "http://localhost:" + port + "/rest/auto/citiesjpa?value=Bern";
		CityDTO[] cities = this.restTemplate.getForObject(url, CityDTO[].class);
		assertNotNull(cities);
		assertEquals(1,  cities.length);
		CityDTO city = cities[0];
		assertNotNull(city);
		assertEquals("Bern", city.getName());
	}
	
    /*
	@Test
	public void testCityAutoCompleteController() throws Exception {
		MvcResult mvcResult = mvc.perform(get("/rest/auto/cities?value=Bern").contentType(MediaType.APPLICATION_JSON))
				.andExpect(status().isOk()).andReturn();
		String expected = "[Bern]";
		String actual = mvcResult.getResponse().getContentAsString();
		JSONAssert.assertEquals(expected, actual, false);
	}
	*/
}
